DIR=/usr/lib/linux-u-boot-edge-xt-q8l-v10
write_uboot_platform () 
{ 
    while [[ -n $DIR ]]; do
        [[ "$BOOT_SOC" != "rk322x" ]] && break;
        SIGNATURE_OFFSET=$(dd if=$2 bs=128k count=1 2> /dev/null | od -A o -w4 -tx4 | grep 'a7866565' | cut -d " " -f 1);
        [[ $? -ne 0 ]] && break;
        [[ -z $SIGNATURE_OFFSET ]] && break;
        CMD_RATE_OFFSET=$(($SIGNATURE_OFFSET - 16));
        CR_BYTE=$(od -A n -t dI -j $CMD_RATE_OFFSET -N 1 $2);
        [[ -z $CR_BYTE ]] && break;
        [[ "$CR_BYTE" -ne 0 && "$CR_BYTE" -ne 1 ]] && break;
        SIGNATURE_OFFSET=$(dd if=$1/u-boot-rk322x-with-spl.bin bs=128k count=1 2> /dev/null | od -A o -w4 -tx4 | grep 'a7866565' | cut -d " " -f 1);
        [[ $? -ne 0 ]] && break;
        [[ -z $SIGNATURE_OFFSET ]] && break;
        CMD_RATE_OFFSET=$(($SIGNATURE_OFFSET - 16));
        DST_BYTE=$(od -A n -t dI -j $CMD_RATE_OFFSET -N 1 $1/u-boot-rk322x-with-spl.bin);
        [[ "$DST_BYTE" -ne 0 && "$DST_BYTE" -ne 1 ]] && break;
        [[ "$CR_BYTE" -eq 0 ]] && HEX_CR="\x00";
        [[ "$CR_BYTE" -eq 1 ]] && HEX_CR="\x01";
        echo -e $HEX_CR | dd of=$1/u-boot-rk322x-with-spl.bin bs=1 seek=$CMD_RATE_OFFSET count=1 conv=notrunc > /dev/null 2>&1;
        break;
    done;
    if [[ "$BOOT_SOC" == "rk3288" ]]; then
        UBOOT_SRC="u-boot-rockchip-with-spl.bin";
    else
        if [[ "$BOOT_SOC" == "rk322x" ]]; then
            UBOOT_SRC="u-boot-rk322x-with-spl.bin";
        fi;
    fi;
    dd if=/dev/zero of=$2 bs=32k count=63 seek=1 status=noxfer > /dev/null 2>&1;
    dd if=$1/$UBOOT_SRC of=$2 bs=32k seek=1 conv=notrunc
}


